#!/bin/echo It can be only inclusion. Incorrect start

# Use this for include.
# [ -z "${_NSG_REVISION_DIALOG}" ] && { . /usr/local/share/nsg/revision/revision_dialog.sh || do_it_if_error; }

_NSG_REVISION_DIALOG=1

[ -z "${_NSG_FUNCTIONS}" ] && { . /usr/local/share/nsg/lib/functions.sh || return 69; }
[ -z "${_NSG_DIALOG}" ] && { . /usr/local/share/nsg/lib/dialog.sh || return 69; }

nsg_revision_dialog_welcome() {
    l_usage() {
	einfo "nsg_revision_dialog_welcome(): function usage: nsg_revision_dialog_welcome [-t timeout] [-d default_choice] var"
    }

    l_restore_tty() {
	[ -n "${l_old_tty_settings}" ] && stty "${l_old_tty_settings}"
    }

    l_return_hook() {
	l_restore_tty
    }

    local l_i l_name l_old_tty_settings
    local l_defchoice l_timeout

    l_timeout="5"
    l_defchoice="1"

    # save tty
    l_old_tty_settings="$(stty -g)"
    stty -echo
    
    while getopts t:d: l_name; do
	case $l_name in
	    (t)
	    l_timeout="$OPTARG"
	    ;;
	    (d)
	    l_defchoice="$OPTARG"
	    if echo "${l_defchoice}" | grep -qv -e '^[123]$'; then
		eerr "nsg_revision_dialog_welcome(): '${l_defchoice}': default_choice argument must one of '1 2 3'"
		l_usage
		l_return_hook
		return ${EX_USAGE}
	    fi
	    ;;
	    (?)
	    l_usage
	    l_return_hook
	    return ${EX_USAGE}
	    ;;
	esac
    done
    shift $(($OPTIND - 1)); OPTIND="1"

    if [ "$#" -ne "1" ]; then
	eerr "nsg_revision_dialog_welcome(): '$@': incorrect quantity of operands"
	l_usage
	l_return_hook
	return ${EX_USAGE}
    fi

    echo ""
    echo "Welcome to NSG Revision Utility!"
    echo ""
    echo "1) continue booting"
    echo "2) update software"
    echo "3) boot with default config"
    echo ""
    echo "timeout='${l_timeout}', default_choice='${l_defchoice}'"
    echo -n "Take your choice: "

    while nsg_wait_getkey -t "${l_timeout}" -d "${l_defchoice}" -- "$@"; do
	echo ""
	if eval echo \"\$$@\" | grep -qv -e '^[123]$' -e '^\\n$'; then
	    echo -n "Try again: "
	    continue
	else
	    if [ "$(eval echo \"\$$@\")" == "\n" ]; then
		eval "$@"='${l_defchoice}'
	    fi
	    eval echo "\$$@"
	    l_return_hook
	    return ${EX_OK}
	fi
    done
    
    l_return_hook
    return ${EX_UNAVAILABLE}
}

nsg_revision_dialog_sure() {
    l_usage() {
	einfo "nsg_revision_dialog_sure(): function usage: nsg_revision_dialog_sure [-t timeout] [-d default_choice] var"
    }
    
    nsg_dialog_sure $@
}
